-- *****************************
-- 创建人员: 杨坤安
-- 创建时间: 2024-08-13
-- 功能描述: GDP、人均可支配收入、常住人口 填报表
-- *****************************



DROP TABLE IF EXISTS sdi_oth.ODS_BASE_METRICS_FILL;
CREATE TABLE sdi_oth.ODS_BASE_METRICS_FILL (
 ID SERIAL PRIMARY KEY
,YEARS              VARCHAR(50)
,PROVINCE           VARCHAR(50)
,CITY               VARCHAR(50)
,COUNTY             VARCHAR(50)
,METRICS_NAME       VARCHAR(50)
,METRICS_VALUE      DECIMAL(16,4)
,UPDATE_DATE        VARCHAR(50)
,UPDATE_BY          VARCHAR(50)
);

-- 为表添加注释
COMMENT ON TABLE sdi_oth.ODS_BASE_METRICS_FILL IS '基础指标填报表';

-- 为字段添加注释
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.ID IS '自增ID';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.YEARS IS '年度';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.PROVINCE IS '省份';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.CITY IS '地市';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.COUNTY IS '区县';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.METRICS_NAME IS '指标分类';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.METRICS_VALUE IS '指标值';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.UPDATE_DATE IS '更新时间';
COMMENT ON COLUMN sdi_oth.ODS_BASE_METRICS_FILL.UPDATE_BY IS '更新人';


SELECT * FROM sdi_oth.ODS_BASE_METRICS_FILL;

-- 数据集
-- 【1_repory_select】
SELECT
    years
     ,province
     ,city
     ,county
     ,metrics_name
     ,metrics_value
FROM sdi_oth.ods_base_metrics_fill
where years = '${p_y}'
  and metrics_name = '${metrics_name}'
;



-- 【2_report_metrics_name】
SELECT
    'GDP(亿元)' AS metrics_name
FROM DUAL
UNION ALL
SELECT
    '人均可支配收入(万元)' AS metrics_name
FROM DUAL
UNION ALL
SELECT
    '常住人口(万人)' AS metrics_name
FROM DUAL
;


